package ccomp.parser;

import java.util.ArrayList;
import static ccomp.parser_hw.HLL_ASTNodes.*;
import beaver.*;
import SFE.Compiler.Operators.*;
import ccomp.parser_hw.*;

/**
 * This class is a LALR parser generated by
 * <a href="http://beaver.sourceforge.net">Beaver</a> v0.9.6.1
 * from the grammar specification "C.grammar".
 */
public class CParser extends Parser {
	static public class Terminals {
		static public final short EOF = 0;
		static public final short LEFT_PAREN = 1;
		static public final short IDENTIFIER = 2;
		static public final short ASTERISK = 3;
		static public final short ADD_OP = 4;
		static public final short MINUS_OP = 5;
		static public final short AMPERSAND = 6;
		static public final short INC_OP = 7;
		static public final short DEC_OP = 8;
		static public final short SIZEOF = 9;
		static public final short CONSTANT = 10;
		static public final short HEX_CONSTANT = 11;
		static public final short OCTAL_CONSTANT = 12;
		static public final short DECIMAL_CONSTANT = 13;
		static public final short FP_CONSTANT = 14;
		static public final short STRING_LITERAL = 15;
		static public final short NEG_OP = 16;
		static public final short NOT_OP = 17;
		static public final short SEMICOLON = 18;
		static public final short RIGHT_PAREN = 19;
		static public final short LEFT_CBRACE = 20;
		static public final short ENUM = 21;
		static public final short VOID = 22;
		static public final short CHAR = 23;
		static public final short SHORT = 24;
		static public final short INT = 25;
		static public final short LONG = 26;
		static public final short FLOAT = 27;
		static public final short DOUBLE = 28;
		static public final short SIGNED = 29;
		static public final short UNSIGNED = 30;
		static public final short TYPE_NAME = 31;
		static public final short STRUCT = 32;
		static public final short UNION = 33;
		static public final short COMMA = 34;
		static public final short CONST = 35;
		static public final short VOLATILE = 36;
		static public final short TYPEDEF = 37;
		static public final short EXTERN = 38;
		static public final short STATIC = 39;
		static public final short AUTO = 40;
		static public final short REGISTER = 41;
		static public final short WHILE = 42;
		static public final short DO = 43;
		static public final short IF = 44;
		static public final short SWITCH = 45;
		static public final short FOR = 46;
		static public final short GOTO = 47;
		static public final short CASE = 48;
		static public final short DEFAULT = 49;
		static public final short CONTINUE = 50;
		static public final short BREAK = 51;
		static public final short RETURN = 52;
		static public final short LEFT_SQBRACE = 53;
		static public final short RIGHT_CBRACE = 54;
		static public final short RIGHT_SQBRACE = 55;
		static public final short COLON = 56;
		static public final short LEFT_OP = 57;
		static public final short RIGHT_OP = 58;
		static public final short ASSIGN = 59;
		static public final short DIV_OP = 60;
		static public final short MOD_OP = 61;
		static public final short LEFT_ANGBRACE = 62;
		static public final short RIGHT_ANGBRACE = 63;
		static public final short LE_OP = 64;
		static public final short GE_OP = 65;
		static public final short EQ_OP = 66;
		static public final short NE_OP = 67;
		static public final short CARET = 68;
		static public final short PIPE = 69;
		static public final short AND_OP = 70;
		static public final short ELSE = 71;
		static public final short PERIOD = 72;
		static public final short PTR_OP = 73;
		static public final short QUESTION = 74;
		static public final short ELLIPSIS = 75;
		static public final short OR_OP = 76;
		static public final short MUL_ASSIGN = 77;
		static public final short DIV_ASSIGN = 78;
		static public final short MOD_ASSIGN = 79;
		static public final short ADD_ASSIGN = 80;
		static public final short SUB_ASSIGN = 81;
		static public final short LEFT_ASSIGN = 82;
		static public final short RIGHT_ASSIGN = 83;
		static public final short AND_ASSIGN = 84;
		static public final short XOR_ASSIGN = 85;
		static public final short OR_ASSIGN = 86;
	}

	static final ParsingTables PARSING_TABLES = new ParsingTables(
		"U9pjMWTuLCKJdxsMTWWaeIeY0GH25GWj5EczzzvH3A55MY2XX5uZ4C2ENK55iOA5Oa6nOW7" +
		"5BeZOiM3zw$n$Rz$UtRlBbVV2VVd0p$k#URCxE$kRsTdoPk#Eo7sM6eYBQJIDeR4qYbfGIx" +
		"gI9j8akegkfibq3OsZyQ8wbH2bw6MwYMwcM#XMsawtqUrq1zr9zz0nUe$Aqxrq7ssbRNGzt" +
		"K0tYiQYkQWfweihHITngKWHNKLtqPEIH6bJjXB3sgfaobPbCP3AKHgrff6KILDf6brBiwWV" +
		"zQK#r9jwKKKgIyt5vRI9Tj1TTBSeImMYdBY8hXD3QAye8ygB2g8YxQDdn52gxuTJKmm8a0m" +
		"IYKMsLSLhgphr5svgG1CYn6UGgHXMHGpDwFq9lOj3nF0raUGtqjGGUg#AmP7zfgVfATeVPb" +
		"wZW61Yl8rCncKszFuNOhpr0#RwyX1wPknqDUdF2kXrCEdFW7Fm9y#2Fw#PycS67Iq6Vp1VF" +
		"CwKFrdKfHZcgmVqAeMmKvk6qaToBTUWWJITPeRG#vGgXrdjLVtFmKAhG3k1KkYazPE9Dk9a" +
		"IZQSJDOHDWEX4iqx1uGjGAZ26POGqdKT82m1mZBQBwfXhgqWjF8YF0S4n5VKeOEM4Dfw4Tu" +
		"2mYhuK8zUiOJWMHDbQPtoeH7LBIB2$K2eHOD5Cui8Rz5mog0NWF0k41wdvqKBYmXB9CApG7" +
		"W320Vmx4YlMq9uHoAygH2qKVIdJwmWCEjl321y3WJj$PfCNteHVFkbJfXTzbF0BejebwwWG" +
		"$fAfb$2u7OCmDNE18r#isJ1DuPXj81Eq#yuK$GnNm8BXK#4QZXJseVnQcU0L$eRruWpX8xZ" +
		"JF58wj6JKYSqueOGfrGR$GGKbz5wKJLqVr4h8DiBancAkW6si6Pe3hmDxLq92#WDBEYcMT1" +
		"D3$0wj6PBqvfjJ6ksjRY#Ivh8qxIub$AkqSxUapsE2YYESkawEa6BgQ7eJ0zH9ot7flT55o" +
		"eDQJx5qsUKJHzJ8tg0aasT4vuLDK9q4#qizPWYUeZsfiSJZSXeQxwKr$uVvFbSP08zyhdGr" +
		"8jtKd5z$vOnuLaqD9wKDhi5pKHydlvDoyDeN28nlZ1r2aRsYEYRY4XdJDZwoyIwIlL6$riJ" +
		"sbUOq6bYGgULYHjZzUZe48aE9ZpgQy9QBnCulIFgL2YcTVsVXhz6f7bfR0BZgoXeHBRIBg9" +
		"6#BEgfwapHlzqFs$cftWqeXUvfL74UYAAM7iYOaLg9syMT2IaxgNq4lHE5SlE$E7Vjtf4vM" +
		"BoM6MnC5a0SY6B9TgBF5N$x1F3oHdcfd6QcY7d9PuYHfC3EUz2rUy4sRYMB2tYiJIV7Wo3u" +
		"V5WZPy7vEV1ILfB7uR1q3vsU11Q8xBzxwJzN6c$CmL#lfTv$3ygZmy#pvT9JHOaXB09kt08" +
		"ft29617hjN4QDlPB6yQuxzOaeeRidS$ZQILi#FBSV7g4vaBIo7lZ68O#gxLlsYa6MXxfA2e" +
		"GGwLKovJVrgCe4a13CJDkhru9w8sGUeSfmIiT2QbRzIQZTy8j$VNi#A#z9QApz2lb6EeFgN" +
		"bx7wLz8XwbNTA7sgX$01yUersYf6X8UqLJYiMpjVIhaMpHn$eYDH9zG2Mf2UGFGqlR2$tmU" +
		"5IELVjurgRs#P5#HbsGJSw#4wid1dtYSDzA0789t41AucPIcX8f7VUkCZWhob5vP5WLwMBa" +
		"v9LmIbN6h5N1VRugLQFgf7tBL1CterIgJNMeBjN3J3T0JjuGLXfJ2hmoOwj9M5kTJDdg29J" +
		"1D8I6qZ0QJYEmraQfdQpjsWb##pY3fgYLE9rcq4pAaYjoDit1kfc7bHE8arT8ihR8jZfuRR" +
		"MZzh0LEJvhJSNGXHYQqUi6lHvXvij$NC7rcfYQLrqZzBmM1q8YncGkBW9wpKACj$1S1zSpO" +
		"oVDWZz9vva$AIRzQNAUnIUd6Fnf2hrE8UneFNMCrjG6EKNR47f9ECL2htPNm3aO$0HAYyB9" +
		"L5I4f696yEXaujoUXXcm0o6dY0YQ3rfyZMy3QmZBWP0aVLXZ2S6p9ZAnGZm#s8k8a0o4viX" +
		"ShI8iHwxR2Z78XE$JS0vcMKQOAn6Ir2WsuJaJg5OGaYL2kaBGHs5jFP3QPPdeDqs#NsTYLG" +
		"H32BtBRAPsMV2LR0k3Epy0LpiJD5fXoO9Hjpj6gwqtVSpDO24OKX8ic1#jZkMFa#ntfZIJE" +
		"aM9dyVF952uTxf$$t2POUS0NMtD9C7Rq3tIBQ1RySIARcg0hddKq9g9HSQClFeYl$sqk2Tx" +
		"rsYMjxGC9qgYFDbp84q2pdnQ8dFiXP1lXZGNESKYt8YNWAyocS7xT1AnowttC3kUQ4H6qp0" +
		"WiVeWCf7HJOpCYvUckExHCjEvzRbfD9CscqRqDAo6IGnj7YDw1AIaw4JMKlJpeuKOdIZ8x3" +
		"WAEYQZQSwZw8o#UDRrVnh#6l#cUOaq5XExGktw1UVDc2wyo5seM17QWU79VS9XpO$QwhbmT" +
		"kQ5j#$KJCBYL12oM3opA4LveNzJ72xFRafPyWswZjPhsgfV3XNG5bbQWZRj6zVG69wrb6Jq" +
		"m1i7tOEqy1XIK$CWj9KYslVwaIBp#7ILnuUOPwdPatfHR#f3VQaVzQS1D906UMq8t1Niygv" +
		"WYBkwFIJAthdm0pOCUQxdzf3YzrtIHayVFscsyZ#DRFeeA0#KBQDerCkJlPDfQR3UFapfNR" +
		"RHN$ZaQzDMLAwXFb#F6#uzy$MrW9A#EkRZtgFVY9QYfjsILigd9akHJtsigr7JlirUAcVyE" +
		"befyP90g$NuQ3DXc9Kkr1Lw9COiaZ$yEDr4ZYbQsKD4RjNcggPpqL3Zw7mCiboVdkiEF19L" +
		"kQm$Hi8FUBoWb#bHejWHuAN1Cy6hW#U2PuDlaB#oKUnsyCNW3nFP5e8V9B8$3luswbf$wDX" +
		"V1p$hio6gm6vDlHpdKhxlGBacx2$mwSKrLxoRuiCLdw9mse4EgFvTOQyl#iCFiGhuPtIvBS" +
		"k7Pvi4MWaw17eNyRi2MElW7$JZ41D71N3ux7WM$0N84OkueyRuM2Nq$z9NTfG2xOViTynV8" +
		"wBuE73OS0s6BOpVgSPdhw3cGlDf6#ejzBgpXG$B1J$54Q8OWVR6Fhcp3ketgFvg7ks72$lb" +
		"tAtu8SK$F9Tn1X#xqmxRxyEFTq3vXZYSmdorL#FuLldu7kAHgfVZ#wZ#b#fSz4UVYdhPXZc" +
		"oJmRj36upuGkTktFGfouANokR3HHF0lviWozDGRrWuyyWM3#1L9niUw3Npj1lb9AFnHoelU" +
		"Hee$W9sC0#Y57pwNQgSRrjwBzMyHt#DXrlGU#iik#2NmF0omKRQoH2$B0$d3DyTRTSozffe" +
		"jVfM6GCnsxuC5xvW$tfr7oQe$1ZKTxfqtLtKlAUqCL#T6jzzw5U2VndrROHRQFHXdZQOfJi" +
		"NiYcG$OKPEaghhqXBm3X74d0#UB6ddGUK$f$8xOVWyxWNB51Dq#Nkrg0r3ox#YcUeVFO6ih" +
		"7mueZphQjAWvfYdyJ98OhG3SNbYUaWZByPUxE0VMBV6LNImFcBeFS3mDJW$Z46CvAr#SwZn" +
		"#XxAeOs3phfq3degqQWpepwGdLNatnWpvCVPtgvTW31blUirUlsqieNa$r#qJLUwlwTCEOd" +
		"bP#$ANpk1f6h52adTNAttOASu$YovLFiMPmGkExgWInUKJdjWh#yeHJXNNTQORsjhwoxKSr" +
		"pkS3C3uovvTjc#9glBRZvpBEyBQS1ptdhHfJ7qDvfAySfyxA#58wjwkpZyhuuzbl0LqIt5P" +
		"yHuDUTKFvGODEam2ylE1OxjQWxceCXqAFBxwJVprX9#RzP#oZyW5wwqDX#EkvnkeyffQg7p" +
		"7JBuZ$6bKsr8VfN8#dPmr4nl6iaVWJgdxSqFPNy3unwXpLvmcybQ5DdOtsKGRP12LRgFXsG" +
		"vltVUcJENz5N4gY3UUx$K1WUn1$JXIMsTNPHcgE7VR2Eku4KAg$J8pHkt43hi$rm1y2xGBT" +
		"mtVZUHSFbAruSt9$xilx#LEKzZ5s0Jy7GcR7o03vPT0h86IdZBSC7mKXM#6FD7tmtq2x#Lj" +
		"PFikFuFaDw6lGLw3JKlwbyWHlD1uE6iOFy$Fy8h$4X$bLr5y3uKt3o3OP6Gv$oB$oAVw2J$" +
		"89$fm$ut$uR$uV$yL$yX#Ch90$u8$vk9QlCt8xVfFVuJV0aH$o86LfCa$Yg$ag7ilpPNqEp" +
		"vPy5kXQq0JEueby3J$83$3zl9Dty7ry9z$1j$Djl9rlvLluPhw9R#GR#7hUnbjv2nVmPixX" +
		"1UWh$$l6ctYTv6j1AndlFru6MWwQ9#LpEPjdyWoUnfaydQVoAbxDQvHtIq6B6FS0pkN5l4J" +
		"AyZYVD$1wMTuedwDuA9v36FF88q4ZLEzVGDYt$1r$ZoUoB$wHp$0FikqJfNE0d#Ld#6b#Yl" +
		"Vo7dwId#37#J5#bFl9kM$7oFaO#GHt1dNYAxaFz#PUt9DxS7V#1x9k2gUhV7RXDdYs9lNXL" +
		"g2MtbgwjzI231zkRYWtayyce3HGOn0oUsuefSWjkIEe0xVbzbn7ocfpAkFUGKTf2sw2myAI" +
		"7NTl0NA0x0QkaKrIFjhpvI#y0cGB80TkxY8e3PVam9rUWEnU6edwICdjkEiBa5tIQ9H7I#w" +
		"ZCP2DaTnEOr4U2puEV1puUF3nu1F09u1F19y8hdqlD8cSydkigr3V06wMhfPabzyNPMDysV" +
		"Bx1G6o5U8hmLUYVIduKl0Pu84qsI9bmEyCn2m3#DUWhj4gIJRSzksu#Mk$XmhSvJNIRlW2P" +
		"0FPQGhwJK5$xJy5Qo1V0zboyENWK#Lt9OBceKtxTc2k93l8OU1wEGjjMT3JoKwRKDV#cx48" +
		"V17gYy4NoszIR8e4RPHafnNWAo1R0gwJZN8Wp$5oZHo5wjglZylahv0EsepoPlcV616KhfN" +
		"$Cd58hltl8rDoZHoKX$OyoBJ$FwwL$maH81lDGbncKOpaioN5W5oIpq7VET3naPqAqAy0vN" +
		"NW6gq7zdh8TRBHrly39ifQEG==");

  private String placeholder_re1 = "Error: SIZEOF unimplemented";
  private String placeholder_re2 = "Error: EQ/NEQ unimplemented";
  private String placeholder_re3 = "Error: ENUM unimplemented";
  private String placeholder_re7 = "Error: CONST/VOLATILE unimplemented";
  private String placeholder_re9 = "Error: abstract declarator unimplemented";
  private String placeholder_re12 = "Error: labels unimplemented";
  private String placeholder_re13 = "Error: switch unimplemented";
  private String int_decimal = "int decimal"; 
  private String int_octal = "int octal"; 
  private String int_hex = "int hex"; 
  
  protected void recoverFromError(Symbol token, TokenStream in) throws java.io.IOException, Parser.Exception
  {
    throw new RuntimeException("Syntax error.");
  }

	private final Action[] actions;

	public CParser() {
		super(PARSING_TABLES);
		actions = new Action[] {
			Action.RETURN,	// [0] $goal = translation_unit
			new Action() {	// [1] primary_expression = IDENTIFIER.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 return new Symbol(new Identifier(a));
				}
			},
			new Action() {	// [2] primary_expression = CONSTANT.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 return new Symbol(new Constant(a,"???"));
				}
			},
			new Action() {	// [3] primary_expression = HEX_CONSTANT.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 return new Symbol(new Constant(a,int_hex));
				}
			},
			new Action() {	// [4] primary_expression = OCTAL_CONSTANT.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 return new Symbol(new Constant(a,int_octal));
				}
			},
			new Action() {	// [5] primary_expression = DECIMAL_CONSTANT.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 return new Symbol(new Constant(a,int_decimal));
				}
			},
			new Action() {	// [6] primary_expression = FP_CONSTANT.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 return new Symbol(new Constant(a,"fp"));
				}
			},
			new Action() {	// [7] primary_expression = STRING_LITERAL.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 return new Symbol(new Constant(a,"string"));
				}
			},
			new Action() {	// [8] primary_expression = LEFT_PAREN expression.a RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final MultiExpression a = (MultiExpression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [9] postfix_expression = primary_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [10] postfix_expression = postfix_expression.a LEFT_SQBRACE expression.b RIGHT_SQBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final MultiExpression b = (MultiExpression) _symbol_b.value;
					
  	//Expand a[b] as *(a + b), so that symmetry is possible 
  	return new Symbol(
  		new UnaryOpExpression(new PointerAccessOperator(), 
  			new BinaryOpExpression(a, new PlusOperator(), b)));
				}
			},
			new Action() {	// [11] postfix_expression = postfix_expression.a LEFT_PAREN RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(new FunctionCall((Identifier)a, new ArrayList()));
				}
			},
			new Action() {	// [12] postfix_expression = postfix_expression.a LEFT_PAREN argument_expression_list.b RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final ArrayList<Expression> b = (ArrayList<Expression>) _symbol_b.value;
					 return new Symbol(new FunctionCall((Identifier)a, b));
				}
			},
			new Action() {	// [13] postfix_expression = postfix_expression.a PERIOD IDENTIFIER.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final String b = (String) _symbol_b.value;
					 return new Symbol(new UnaryOpExpression(new StructAccessOperator(b), a));
				}
			},
			new Action() {	// [14] postfix_expression = postfix_expression.a PTR_OP IDENTIFIER.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final String b = (String) _symbol_b.value;
					 return new Symbol(
  	new UnaryOpExpression(new StructAccessOperator(b), 
  			new UnaryOpExpression(new PointerAccessOperator(), a)));
				}
			},
			new Action() {	// [15] postfix_expression = postfix_expression.a INC_OP
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(
  		new BinaryOpExpression(new AssignmentStatement(a, "+=", new Constant(1, int_decimal)), new MinusOperator(), new Constant(1, int_decimal)));
				}
			},
			new Action() {	// [16] postfix_expression = postfix_expression.a DEC_OP
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(
  		new BinaryOpExpression(new AssignmentStatement(a, "-=", new Constant(1, int_decimal)), new PlusOperator(), new Constant(1, int_decimal)));
				}
			},
			new Action() {	// [17] argument_expression_list = assignment_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 ArrayList<Expression> s = new ArrayList(); s.add(a); return new Symbol(s);
				}
			},
			new Action() {	// [18] argument_expression_list = argument_expression_list.a COMMA assignment_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final ArrayList<Expression> a = (ArrayList<Expression>) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 a.add(b); return new Symbol(a);
				}
			},
			new Action() {	// [19] unary_expression = postfix_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [20] unary_expression = INC_OP unary_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(
  		new AssignmentStatement(a, "+=", new Constant(1, int_decimal)));
				}
			},
			new Action() {	// [21] unary_expression = DEC_OP unary_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(
  		new AssignmentStatement(a, "-=", new Constant(1, int_decimal)));
				}
			},
			new Action() {	// [22] unary_expression = unary_operator.a cast_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Operator a = (Operator) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new UnaryOpExpression(a,b));
				}
			},
			new Action() {	// [23] unary_expression = SIZEOF unary_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final Expression a = (Expression) _symbol_a.value;
					 throw new RuntimeException(placeholder_re1+" at "+_symbol_a.getLine(_symbol_a.getStart())+":"+_symbol_a.getColumn(_symbol_a.getStart()));
				}
			},
			new Action() {	// [24] unary_expression = SIZEOF LEFT_PAREN type_name.a RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 3];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 throw new RuntimeException(placeholder_re1+" at "+_symbol_a.getLine(_symbol_a.getStart())+":"+_symbol_a.getColumn(_symbol_a.getStart()));
				}
			},
			new Action() {	// [25] unary_operator = AMPERSAND
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new GetPointerOperator());
				}
			},
			new Action() {	// [26] unary_operator = ASTERISK
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new PointerAccessOperator());
				}
			},
			new Action() {	// [27] unary_operator = ADD_OP
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new UnaryPlusOperator());
				}
			},
			new Action() {	// [28] unary_operator = MINUS_OP
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new UnaryMinusOperator());
				}
			},
			new Action() {	// [29] unary_operator = NEG_OP
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new BitwiseNotOperator());
				}
			},
			new Action() {	// [30] unary_operator = NOT_OP
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new NotOperator());
				}
			},
			new Action() {	// [31] cast_expression = unary_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [32] cast_expression = LEFT_PAREN type_name.a RIGHT_PAREN cast_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 4];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new CastExpression(a,b));
				}
			},
			new Action() {	// [33] multiplicative_expression = cast_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [34] multiplicative_expression = multiplicative_expression.a ASTERISK cast_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new TimesOperator(), b));
				}
			},
			new Action() {	// [35] multiplicative_expression = multiplicative_expression.a DIV_OP cast_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new DivisionOperator(DivisionOperator.QUOTIENT), b));
				}
			},
			new Action() {	// [36] multiplicative_expression = multiplicative_expression.a MOD_OP cast_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new DivisionOperator(DivisionOperator.REMAINDER), b));
				}
			},
			new Action() {	// [37] additive_expression = multiplicative_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [38] additive_expression = additive_expression.a ADD_OP multiplicative_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new PlusOperator(), b));
				}
			},
			new Action() {	// [39] additive_expression = additive_expression.a MINUS_OP multiplicative_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new MinusOperator(), b));
				}
			},
			new Action() {	// [40] shift_expression = additive_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [41] shift_expression = shift_expression.a LEFT_OP additive_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new BitwiseShiftOperator(BitwiseShiftOperator.LEFT_SHIFT), b));
				}
			},
			new Action() {	// [42] shift_expression = shift_expression.a RIGHT_OP additive_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new BitwiseShiftOperator(BitwiseShiftOperator.RIGHT_SHIFT), b));
				}
			},
			new Action() {	// [43] relational_expression = shift_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [44] relational_expression = relational_expression.a LEFT_ANGBRACE shift_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new LessOperator(), b));
				}
			},
			new Action() {	// [45] relational_expression = relational_expression.a RIGHT_ANGBRACE shift_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new GreaterOperator(), b));
				}
			},
			new Action() {	// [46] relational_expression = relational_expression.a LE_OP shift_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new LessEqualOperator(), b));
				}
			},
			new Action() {	// [47] relational_expression = relational_expression.a GE_OP shift_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new BinaryOpExpression(a, new GreaterEqualOperator(), b));
				}
			},
			new Action() {	// [48] equality_expression = relational_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [49] equality_expression = equality_expression.a EQ_OP relational_expression
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 throw new RuntimeException(placeholder_re2+" at "+_symbol_a.getLine(_symbol_a.getStart())+":"+_symbol_a.getColumn(_symbol_a.getStart()));
				}
			},
			new Action() {	// [50] equality_expression = equality_expression.a NE_OP relational_expression
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 throw new RuntimeException(placeholder_re2+" at "+_symbol_a.getLine(_symbol_a.getStart())+":"+_symbol_a.getColumn(_symbol_a.getStart()));
				}
			},
			new Action() {	// [51] and_expression = equality_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [52] and_expression = and_expression.a AMPERSAND.b equality_expression.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol b = _symbols[offset + 2];
					final Symbol _symbol_c = _symbols[offset + 3];
					final Expression c = (Expression) _symbol_c.value;
					 return new Symbol(new BinaryOpExpression(a,new BitwiseAndOperator(),c));
				}
			},
			new Action() {	// [53] exclusive_or_expression = and_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [54] exclusive_or_expression = exclusive_or_expression.a CARET.b and_expression.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol b = _symbols[offset + 2];
					final Symbol _symbol_c = _symbols[offset + 3];
					final Expression c = (Expression) _symbol_c.value;
					 return new Symbol(new BinaryOpExpression(a,new BitwiseXOROperator(),c));
				}
			},
			new Action() {	// [55] inclusive_or_expression = exclusive_or_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [56] inclusive_or_expression = inclusive_or_expression.a PIPE.b exclusive_or_expression.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol b = _symbols[offset + 2];
					final Symbol _symbol_c = _symbols[offset + 3];
					final Expression c = (Expression) _symbol_c.value;
					 return new Symbol(new BinaryOpExpression(a,new BitwiseOrOperator(),c));
				}
			},
			new Action() {	// [57] logical_and_expression = inclusive_or_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [58] logical_and_expression = logical_and_expression.a AND_OP.b inclusive_or_expression.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol b = _symbols[offset + 2];
					final Symbol _symbol_c = _symbols[offset + 3];
					final Expression c = (Expression) _symbol_c.value;
					 return new Symbol(new BinaryOpExpression(a,new AndOperator(),c));
				}
			},
			new Action() {	// [59] logical_or_expression = logical_and_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [60] logical_or_expression = logical_or_expression.a OR_OP.b logical_and_expression.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol b = _symbols[offset + 2];
					final Symbol _symbol_c = _symbols[offset + 3];
					final Expression c = (Expression) _symbol_c.value;
					 return new Symbol(new BinaryOpExpression(a,new OrOperator(),c));
				}
			},
			new Action() {	// [61] conditional_expression = logical_or_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [62] conditional_expression = logical_or_expression.cond QUESTION expression.the COLON conditional_expression.els
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_cond = _symbols[offset + 1];
					final Expression cond = (Expression) _symbol_cond.value;
					final Symbol _symbol_the = _symbols[offset + 3];
					final MultiExpression the = (MultiExpression) _symbol_the.value;
					final Symbol _symbol_els = _symbols[offset + 5];
					final Expression els = (Expression) _symbol_els.value;
					 return new Symbol(new ConditionalExpression(cond,the,els));
				}
			},
			new Action() {	// [63] assignment_expression = conditional_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [64] assignment_expression = unary_expression.a assignment_operator.b assignment_expression.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final String b = (String) _symbol_b.value;
					final Symbol _symbol_c = _symbols[offset + 3];
					final Expression c = (Expression) _symbol_c.value;
					 return new Symbol(new AssignmentStatement(a,b,c));
				}
			},
			Action.RETURN,	// [65] assignment_operator = ASSIGN
			Action.RETURN,	// [66] assignment_operator = MUL_ASSIGN
			Action.RETURN,	// [67] assignment_operator = DIV_ASSIGN
			Action.RETURN,	// [68] assignment_operator = MOD_ASSIGN
			Action.RETURN,	// [69] assignment_operator = ADD_ASSIGN
			Action.RETURN,	// [70] assignment_operator = SUB_ASSIGN
			Action.RETURN,	// [71] assignment_operator = LEFT_ASSIGN
			Action.RETURN,	// [72] assignment_operator = RIGHT_ASSIGN
			Action.RETURN,	// [73] assignment_operator = AND_ASSIGN
			Action.RETURN,	// [74] assignment_operator = XOR_ASSIGN
			Action.RETURN,	// [75] assignment_operator = OR_ASSIGN
			new Action() {	// [76] expression = assignment_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 MultiExpression s = new MultiExpression(); s.add(a); return new Symbol(s);
				}
			},
			new Action() {	// [77] expression = expression.a COMMA assignment_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final MultiExpression a = (MultiExpression) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 a.add(b); return new Symbol(a);
				}
			},
			new Action() {	// [78] constant_expression = conditional_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [79] declaration = declaration_specifiers.a SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 
    //This is like a typedef.
	if (a instanceof StructTypeSpecification){
		return new Symbol(a);
	} else if (a.spec.startsWith("typedef ")){
		return new Symbol(a);
	}    
	throw new RuntimeException("I don't know how to treat type "+a+" as a declaration.");
				}
			},
			new Action() {	// [80] declaration = declaration_specifiers.a init_declarator_list.b SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final ArrayList<AssignmentStatement> b = (ArrayList<AssignmentStatement>) _symbol_b.value;
					
    //Build the list of assignments
    MultiVariableDeclaration decls = new MultiVariableDeclaration(); 
    for (AssignmentStatement c : b){
      VariableDeclaration a2 = new VariableDeclaration(a, c);
      decls.add(a2);
    }
    return new Symbol(decls);
				}
			},
			new Action() {	// [81] declaration_specifiers = storage_class_specifier.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_b = _symbols[offset + 1];
					final TypeSpecification b = (TypeSpecification) _symbol_b.value;
					 return new Symbol(b);
				}
			},
			new Action() {	// [82] declaration_specifiers = storage_class_specifier.b declaration_specifiers.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_b = _symbols[offset + 1];
					final TypeSpecification b = (TypeSpecification) _symbol_b.value;
					final Symbol _symbol_a = _symbols[offset + 2];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 b.appendTypeSpecification(a); return new Symbol(b);
				}
			},
			new Action() {	// [83] declaration_specifiers = type_specifier.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_b = _symbols[offset + 1];
					final TypeSpecification b = (TypeSpecification) _symbol_b.value;
					 return new Symbol(b);
				}
			},
			new Action() {	// [84] declaration_specifiers = type_specifier.b declaration_specifiers.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_b = _symbols[offset + 1];
					final TypeSpecification b = (TypeSpecification) _symbol_b.value;
					final Symbol _symbol_a = _symbols[offset + 2];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 b.appendTypeSpecification(a); return new Symbol(b);
				}
			},
			new Action() {	// [85] declaration_specifiers = type_qualifier.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_b = _symbols[offset + 1];
					final TypeSpecification b = (TypeSpecification) _symbol_b.value;
					 return new Symbol(b);
				}
			},
			new Action() {	// [86] declaration_specifiers = type_qualifier.b declaration_specifiers.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_b = _symbols[offset + 1];
					final TypeSpecification b = (TypeSpecification) _symbol_b.value;
					final Symbol _symbol_a = _symbols[offset + 2];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 b.appendTypeSpecification(a); return new Symbol(b);
				}
			},
			new Action() {	// [87] init_declarator_list = init_declarator.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final AssignmentStatement a = (AssignmentStatement) _symbol_a.value;
					 ArrayList<AssignmentStatement> s = new ArrayList(); s.add(a); return new Symbol(s);
				}
			},
			new Action() {	// [88] init_declarator_list = init_declarator_list.a COMMA init_declarator.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final ArrayList<AssignmentStatement> a = (ArrayList<AssignmentStatement>) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final AssignmentStatement b = (AssignmentStatement) _symbol_b.value;
					 a.add(b); return new Symbol(a);
				}
			},
			new Action() {	// [89] init_declarator = declarator.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Identifier a = (Identifier) _symbol_a.value;
					 return new Symbol(new AssignmentStatement(a,null));
				}
			},
			new Action() {	// [90] init_declarator = declarator.a ASSIGN initializer.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Identifier a = (Identifier) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 return new Symbol(new AssignmentStatement(a,b));
				}
			},
			new Action() {	// [91] storage_class_specifier = TYPEDEF
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("typedef"));
				}
			},
			new Action() {	// [92] storage_class_specifier = EXTERN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("extern"));
				}
			},
			new Action() {	// [93] storage_class_specifier = STATIC
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("static"));
				}
			},
			new Action() {	// [94] storage_class_specifier = AUTO
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("auto"));
				}
			},
			new Action() {	// [95] storage_class_specifier = REGISTER
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("register"));
				}
			},
			new Action() {	// [96] type_specifier = VOID
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("void"));
				}
			},
			new Action() {	// [97] type_specifier = CHAR
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("char"));
				}
			},
			new Action() {	// [98] type_specifier = SHORT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("short"));
				}
			},
			new Action() {	// [99] type_specifier = INT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("int"));
				}
			},
			new Action() {	// [100] type_specifier = LONG
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("long"));
				}
			},
			new Action() {	// [101] type_specifier = FLOAT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("float"));
				}
			},
			new Action() {	// [102] type_specifier = DOUBLE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("double"));
				}
			},
			new Action() {	// [103] type_specifier = SIGNED
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("signed"));
				}
			},
			new Action() {	// [104] type_specifier = UNSIGNED
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("unsigned"));
				}
			},
			new Action() {	// [105] type_specifier = struct_or_union_specifier.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [106] type_specifier = enum_specifier.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re3+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [107] type_specifier = TYPE_NAME.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 return new Symbol(new TypeSpecification(a));
				}
			},
			new Action() {	// [108] struct_or_union_specifier = struct_or_union.a IDENTIFIER.b LEFT_CBRACE struct_declaration_list.c RIGHT_CBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final String b = (String) _symbol_b.value;
					final Symbol _symbol_c = _symbols[offset + 4];
					final ArrayList<VariableDeclaration> c = (ArrayList<VariableDeclaration>) _symbol_c.value;
					 return new Symbol(new StructTypeSpecification(a, b, c));
				}
			},
			new Action() {	// [109] struct_or_union_specifier = struct_or_union.a LEFT_CBRACE struct_declaration_list.b RIGHT_CBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final ArrayList<VariableDeclaration> b = (ArrayList<VariableDeclaration>) _symbol_b.value;
					 return new Symbol(new StructTypeSpecification(a, null, b));
				}
			},
			new Action() {	// [110] struct_or_union_specifier = struct_or_union.a IDENTIFIER.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final String b = (String) _symbol_b.value;
					 return new Symbol(new TypeSpecification(a+" "+b));
				}
			},
			new Action() {	// [111] struct_or_union = STRUCT
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol("struct");
				}
			},
			new Action() {	// [112] struct_or_union = UNION
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 throw new RuntimeException("Unions not yet supported");
				}
			},
			new Action() {	// [113] struct_declaration_list = struct_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final ArrayList<VariableDeclaration> a = (ArrayList<VariableDeclaration>) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [114] struct_declaration_list = struct_declaration_list.a struct_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final ArrayList<VariableDeclaration> a = (ArrayList<VariableDeclaration>) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final ArrayList<VariableDeclaration> b = (ArrayList<VariableDeclaration>) _symbol_b.value;
					 a.addAll(b); return new Symbol(a);
				}
			},
			new Action() {	// [115] struct_declaration = specifier_qualifier_list.a struct_declarator_list.b SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final ArrayList<VariableDeclaration> b = (ArrayList<VariableDeclaration>) _symbol_b.value;
					 
    for(VariableDeclaration q : b){
      q.setType(a);
    }
    return new Symbol(b);
				}
			},
			new Action() {	// [116] specifier_qualifier_list = type_specifier.a specifier_qualifier_list.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final TypeSpecification b = (TypeSpecification) _symbol_b.value;
					 a.appendTypeSpecification(b); return new Symbol(a);
				}
			},
			new Action() {	// [117] specifier_qualifier_list = type_specifier.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [118] struct_declarator_list = struct_declarator.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final VariableDeclaration a = (VariableDeclaration) _symbol_a.value;
					 ArrayList<VariableDeclaration> p = new ArrayList(); p.add(a); return new Symbol(p);
				}
			},
			new Action() {	// [119] struct_declarator_list = struct_declarator_list.a COMMA struct_declarator.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final ArrayList<VariableDeclaration> a = (ArrayList<VariableDeclaration>) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final VariableDeclaration b = (VariableDeclaration) _symbol_b.value;
					 a.add(b); return new Symbol(a);
				}
			},
			new Action() {	// [120] struct_declarator = declarator.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Identifier a = (Identifier) _symbol_a.value;
					 return new Symbol(new VariableDeclaration(a));
				}
			},
			new Action() {	// [121] struct_declarator = COLON constant_expression
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 throw new RuntimeException("Anonymous fields in structs not supported.");
				}
			},
			new Action() {	// [122] struct_declarator = declarator.a COLON constant_expression.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Identifier a = (Identifier) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 VariableDeclaration v = new VariableDeclaration(a); v.setInitializer(b); return new Symbol(v);
				}
			},
			new Action() {	// [123] enum_specifier = ENUM LEFT_CBRACE enumerator_list.a RIGHT_CBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 3];
					 throw new RuntimeException(placeholder_re3+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [124] enum_specifier = ENUM IDENTIFIER LEFT_CBRACE enumerator_list.a RIGHT_CBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 4];
					 throw new RuntimeException(placeholder_re3+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [125] enum_specifier = ENUM.a IDENTIFIER
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re3+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [126] enumerator_list = enumerator.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re3+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [127] enumerator_list = enumerator_list.a COMMA enumerator
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re3+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [128] enumerator = IDENTIFIER.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 throw new RuntimeException(placeholder_re3+" at "+_symbol_a.getLine(_symbol_a.getStart())+":"+_symbol_a.getColumn(_symbol_a.getStart()));
				}
			},
			new Action() {	// [129] enumerator = IDENTIFIER.a ASSIGN constant_expression
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 throw new RuntimeException(placeholder_re3+" at "+_symbol_a.getLine(_symbol_a.getStart())+":"+_symbol_a.getColumn(_symbol_a.getStart()));
				}
			},
			new Action() {	// [130] type_qualifier = CONST.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re7+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [131] type_qualifier = VOLATILE.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re7+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [132] declarator = pointer.p direct_declarator.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_p = _symbols[offset + 1];
					final TypeSpecification p = (TypeSpecification) _symbol_p.value;
					final Symbol _symbol_a = _symbols[offset + 2];
					final Identifier a = (Identifier) _symbol_a.value;
					 a.setPointer(p); return new Symbol(a);
				}
			},
			new Action() {	// [133] declarator = direct_declarator.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Identifier a = (Identifier) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [134] direct_declarator = IDENTIFIER.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 return new Symbol(new Identifier(a));
				}
			},
			new Action() {	// [135] direct_declarator = LEFT_PAREN declarator RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 throw new RuntimeException("I don't know how to parse ( declarator ).");
				}
			},
			new Action() {	// [136] direct_declarator = direct_declarator.a LEFT_SQBRACE.b constant_expression.c RIGHT_SQBRACE.d
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Identifier a = (Identifier) _symbol_a.value;
					final Symbol b = _symbols[offset + 2];
					final Symbol _symbol_c = _symbols[offset + 3];
					final Expression c = (Expression) _symbol_c.value;
					final Symbol d = _symbols[offset + 4];
					 a.addArrayDeclaration(c); return new Symbol(a);
				}
			},
			new Action() {	// [137] direct_declarator = direct_declarator.a LEFT_SQBRACE.b RIGHT_SQBRACE.c
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Identifier a = (Identifier) _symbol_a.value;
					final Symbol b = _symbols[offset + 2];
					final Symbol c = _symbols[offset + 3];
					 throw new RuntimeException("I don't know how to parse declarator [].");
				}
			},
			new Action() {	// [138] direct_declarator = direct_declarator.a LEFT_PAREN parameter_type_list.b RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Identifier a = (Identifier) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final ArrayList<VariableDeclaration> b = (ArrayList<VariableDeclaration>) _symbol_b.value;
					 a.setArgumentDeclarations(b); return new Symbol(a);
				}
			},
			new Action() {	// [139] direct_declarator = direct_declarator.a LEFT_PAREN identifier_list.b RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Identifier a = (Identifier) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final ArrayList<Identifier> b = (ArrayList<Identifier>) _symbol_b.value;
					 a.setDefaultArgumentDeclarations(b); return new Symbol(a);
				}
			},
			new Action() {	// [140] direct_declarator = direct_declarator.a LEFT_PAREN RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Identifier a = (Identifier) _symbol_a.value;
					 a.setArgumentDeclarations(new ArrayList()); return new Symbol(a);
				}
			},
			new Action() {	// [141] pointer = ASTERISK
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new TypeSpecification("*"));
				}
			},
			new Action() {	// [142] pointer = ASTERISK type_qualifier_list.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 TypeSpecification toRet = new TypeSpecification("*"); toRet.appendTypeSpecification(a); return new Symbol(toRet);
				}
			},
			new Action() {	// [143] pointer = ASTERISK pointer.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 TypeSpecification toRet = new TypeSpecification("*"); toRet.appendTypeSpecification(a); return new Symbol(toRet);
				}
			},
			new Action() {	// [144] pointer = ASTERISK type_qualifier_list.a pointer.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final TypeSpecification b = (TypeSpecification) _symbol_b.value;
					 TypeSpecification toRet = new TypeSpecification("*"); toRet.appendTypeSpecification(a); toRet.appendTypeSpecification(b); return new Symbol(toRet);
				}
			},
			new Action() {	// [145] type_qualifier_list = type_qualifier.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 throw new RuntimeException(placeholder_re7+" at "+_symbol_a.getLine(_symbol_a.getStart())+":"+_symbol_a.getColumn(_symbol_a.getStart()));
				}
			},
			new Action() {	// [146] type_qualifier_list = type_qualifier_list type_qualifier.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 throw new RuntimeException(placeholder_re7+" at "+_symbol_a.getLine(_symbol_a.getStart())+":"+_symbol_a.getColumn(_symbol_a.getStart()));
				}
			},
			new Action() {	// [147] parameter_type_list = parameter_list.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final ArrayList<VariableDeclaration> a = (ArrayList<VariableDeclaration>) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [148] parameter_type_list = parameter_list COMMA ELLIPSIS
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 throw new RuntimeException("I don't know how to parse parameter_list, ...");
				}
			},
			new Action() {	// [149] parameter_list = parameter_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final VariableDeclaration a = (VariableDeclaration) _symbol_a.value;
					 ArrayList<VariableDeclaration> toRet = new ArrayList(); toRet.add(a); return new Symbol(toRet);
				}
			},
			new Action() {	// [150] parameter_list = parameter_list.a COMMA parameter_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final ArrayList<VariableDeclaration> a = (ArrayList<VariableDeclaration>) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final VariableDeclaration b = (VariableDeclaration) _symbol_b.value;
					 a.add(b); return new Symbol(a);
				}
			},
			new Action() {	// [151] parameter_declaration = declaration_specifiers.a declarator.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final Identifier b = (Identifier) _symbol_b.value;
					 return new Symbol(new VariableDeclaration(a,b));
				}
			},
			new Action() {	// [152] parameter_declaration = declaration_specifiers abstract_declarator
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 throw new RuntimeException("I don't know how to parse declaration_specifiers abstract_declarator. ");
				}
			},
			new Action() {	// [153] parameter_declaration = declaration_specifiers.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 return new Symbol(new VariableDeclaration(a));
				}
			},
			new Action() {	// [154] identifier_list = IDENTIFIER.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final String a = (String) _symbol_a.value;
					 ArrayList<Identifier> toRet = new ArrayList(); toRet.add(new Identifier(a)); return new Symbol(toRet);
				}
			},
			new Action() {	// [155] identifier_list = identifier_list.toRet COMMA IDENTIFIER.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_toRet = _symbols[offset + 1];
					final ArrayList<Identifier> toRet = (ArrayList<Identifier>) _symbol_toRet.value;
					final Symbol _symbol_a = _symbols[offset + 3];
					final String a = (String) _symbol_a.value;
					 toRet.add(new Identifier(a)); return new Symbol(toRet);
				}
			},
			new Action() {	// [156] type_name = specifier_qualifier_list.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [157] type_name = specifier_qualifier_list abstract_declarator.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [158] abstract_declarator = pointer.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final TypeSpecification a = (TypeSpecification) _symbol_a.value;
					 throw new RuntimeException(placeholder_re9+" at "+_symbol_a.getLine(_symbol_a.getStart())+":"+_symbol_a.getColumn(_symbol_a.getStart()));
				}
			},
			new Action() {	// [159] abstract_declarator = direct_abstract_declarator.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [160] abstract_declarator = pointer direct_abstract_declarator.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [161] direct_abstract_declarator = LEFT_PAREN.a abstract_declarator RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [162] direct_abstract_declarator = LEFT_SQBRACE.a RIGHT_SQBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [163] direct_abstract_declarator = LEFT_SQBRACE.a constant_expression RIGHT_SQBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [164] direct_abstract_declarator = direct_abstract_declarator.a LEFT_SQBRACE RIGHT_SQBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [165] direct_abstract_declarator = direct_abstract_declarator.a LEFT_SQBRACE constant_expression RIGHT_SQBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [166] direct_abstract_declarator = LEFT_PAREN.a RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [167] direct_abstract_declarator = LEFT_PAREN.a parameter_type_list RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [168] direct_abstract_declarator = direct_abstract_declarator.a LEFT_PAREN RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [169] direct_abstract_declarator = direct_abstract_declarator.a LEFT_PAREN parameter_type_list RIGHT_PAREN
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 1];
					 throw new RuntimeException(placeholder_re9+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [170] initializer = assignment_expression.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [171] initializer = LEFT_CBRACE initializer_list.a RIGHT_CBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final ArrayList<Expression> a = (ArrayList<Expression>) _symbol_a.value;
					 return new Symbol(new MultiExpression(a));
				}
			},
			new Action() {	// [172] initializer = LEFT_CBRACE initializer_list.a COMMA RIGHT_CBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final ArrayList<Expression> a = (ArrayList<Expression>) _symbol_a.value;
					 return new Symbol(new MultiExpression(a));
				}
			},
			new Action() {	// [173] initializer_list = initializer.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Expression a = (Expression) _symbol_a.value;
					 ArrayList<Expression> s = new ArrayList(); s.add(a); return new Symbol(s);
				}
			},
			new Action() {	// [174] initializer_list = initializer_list.a COMMA initializer.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final ArrayList<Expression> a = (ArrayList<Expression>) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final Expression b = (Expression) _symbol_b.value;
					 a.add(b); return new Symbol(a);
				}
			},
			new Action() {	// [175] statement = labeled_statement.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Statement a = (Statement) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [176] statement = compound_statement.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Statement a = (Statement) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [177] statement = expression_statement.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Statement a = (Statement) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [178] statement = selection_statement.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Statement a = (Statement) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [179] statement = iteration_statement.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Statement a = (Statement) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [180] statement = jump_statement.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Statement a = (Statement) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [181] labeled_statement = IDENTIFIER COLON.a statement
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 throw new RuntimeException(placeholder_re12+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [182] labeled_statement = CASE constant_expression COLON.a statement
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 3];
					 throw new RuntimeException(placeholder_re12+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [183] labeled_statement = DEFAULT COLON.a statement
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 throw new RuntimeException(placeholder_re12+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [184] compound_statement = LEFT_CBRACE RIGHT_CBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new CompoundStatement(new ArrayList(), new ArrayList()));
				}
			},
			new Action() {	// [185] compound_statement = LEFT_CBRACE statement_list.a RIGHT_CBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final ArrayList<Statement> a = (ArrayList<Statement>) _symbol_a.value;
					 return new Symbol(new CompoundStatement(new ArrayList(), a));
				}
			},
			new Action() {	// [186] compound_statement = LEFT_CBRACE declaration_list.a RIGHT_CBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final ArrayList<Declaration> a = (ArrayList<Declaration>) _symbol_a.value;
					 return new Symbol(new CompoundStatement(a,new ArrayList()));
				}
			},
			new Action() {	// [187] compound_statement = LEFT_CBRACE declaration_list.a statement_list.b RIGHT_CBRACE
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final ArrayList<Declaration> a = (ArrayList<Declaration>) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 3];
					final ArrayList<Statement> b = (ArrayList<Statement>) _symbol_b.value;
					 return new Symbol(new CompoundStatement(a,b));
				}
			},
			new Action() {	// [188] declaration_list = declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Declaration a = (Declaration) _symbol_a.value;
					 ArrayList<Declaration> toRet = new ArrayList(); toRet.add(a); return new Symbol(toRet);
				}
			},
			new Action() {	// [189] declaration_list = declaration_list.a declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final ArrayList<Declaration> a = (ArrayList<Declaration>) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final Declaration b = (Declaration) _symbol_b.value;
					 a.add(b); return new Symbol(a);
				}
			},
			new Action() {	// [190] statement_list = statement.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Statement a = (Statement) _symbol_a.value;
					 ArrayList<Statement> toRet = new ArrayList(); toRet.add(a); return new Symbol(toRet);
				}
			},
			new Action() {	// [191] statement_list = statement_list.a statement.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final ArrayList<Statement> a = (ArrayList<Statement>) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final Statement b = (Statement) _symbol_b.value;
					 a.add(b); return new Symbol(a);
				}
			},
			new Action() {	// [192] expression_statement = SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new CompoundStatement());
				}
			},
			new Action() {	// [193] expression_statement = expression.a SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final MultiExpression a = (MultiExpression) _symbol_a.value;
					 return new Symbol((Statement)a);
				}
			},
			new Action() {	// [194] selection_statement = IF LEFT_PAREN expression.cond RIGHT_PAREN statement.the
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_cond = _symbols[offset + 3];
					final MultiExpression cond = (MultiExpression) _symbol_cond.value;
					final Symbol _symbol_the = _symbols[offset + 5];
					final Statement the = (Statement) _symbol_the.value;
					 return new Symbol(new IfStatement(cond, the, null));
				}
			},
			new Action() {	// [195] selection_statement = IF LEFT_PAREN expression.cond RIGHT_PAREN statement.the ELSE statement.els
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_cond = _symbols[offset + 3];
					final MultiExpression cond = (MultiExpression) _symbol_cond.value;
					final Symbol _symbol_the = _symbols[offset + 5];
					final Statement the = (Statement) _symbol_the.value;
					final Symbol _symbol_els = _symbols[offset + 7];
					final Statement els = (Statement) _symbol_els.value;
					 return new Symbol(new IfStatement(cond, the, els));
				}
			},
			new Action() {	// [196] selection_statement = SWITCH LEFT_PAREN.a expression RIGHT_PAREN statement
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol a = _symbols[offset + 2];
					 throw new RuntimeException(placeholder_re13+" at "+a.getLine(a.getStart())+":"+a.getColumn(a.getStart()));
				}
			},
			new Action() {	// [197] iteration_statement = WHILE LEFT_PAREN expression.cond RIGHT_PAREN statement.block
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_cond = _symbols[offset + 3];
					final MultiExpression cond = (MultiExpression) _symbol_cond.value;
					final Symbol _symbol_block = _symbols[offset + 5];
					final Statement block = (Statement) _symbol_block.value;
					
  	Expression cond2 = null;
   	if (cond instanceof Expression){
   		cond2 = (Expression)cond;
   	} 
  	return new Symbol(new LoopStatement(new CompoundStatement(), cond2, block, null));
				}
			},
			new Action() {	// [198] iteration_statement = DO statement.block WHILE LEFT_PAREN expression.cond RIGHT_PAREN SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_block = _symbols[offset + 2];
					final Statement block = (Statement) _symbol_block.value;
					final Symbol _symbol_cond = _symbols[offset + 5];
					final MultiExpression cond = (MultiExpression) _symbol_cond.value;
					
  	Expression cond2 = null;
   	if (cond instanceof Expression){
   		cond2 = (Expression)cond;
   	} 
  	return new Symbol(new LoopStatement(block, cond2, block, null));
				}
			},
			new Action() {	// [199] iteration_statement = FOR LEFT_PAREN expression_statement.pre expression_statement.cond RIGHT_PAREN statement.block
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_pre = _symbols[offset + 3];
					final Statement pre = (Statement) _symbol_pre.value;
					final Symbol _symbol_cond = _symbols[offset + 4];
					final Statement cond = (Statement) _symbol_cond.value;
					final Symbol _symbol_block = _symbols[offset + 6];
					final Statement block = (Statement) _symbol_block.value;
					
  	Expression cond2 = null;
   	if (cond instanceof Expression){
   		cond2 = (Expression)cond;
   	} 
  	return new Symbol(new LoopStatement(pre, cond2, block, null));
				}
			},
			new Action() {	// [200] iteration_statement = FOR LEFT_PAREN expression_statement.pre expression_statement.cond expression.advance RIGHT_PAREN statement.block
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_pre = _symbols[offset + 3];
					final Statement pre = (Statement) _symbol_pre.value;
					final Symbol _symbol_cond = _symbols[offset + 4];
					final Statement cond = (Statement) _symbol_cond.value;
					final Symbol _symbol_advance = _symbols[offset + 5];
					final MultiExpression advance = (MultiExpression) _symbol_advance.value;
					final Symbol _symbol_block = _symbols[offset + 7];
					final Statement block = (Statement) _symbol_block.value;
					
  	Expression cond2 = null;
   	if (cond instanceof Expression){
   		cond2 = (Expression)cond;
   	} 
  	return new Symbol(new LoopStatement(pre, cond2, block, advance));
				}
			},
			new Action() {	// [201] jump_statement = GOTO IDENTIFIER SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 throw new RuntimeException("I don't know how to parse GOTO IDENTIFIER SEMICOLON.");
				}
			},
			new Action() {	// [202] jump_statement = CONTINUE SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new ContinueStatement());
				}
			},
			new Action() {	// [203] jump_statement = BREAK SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new BreakStatement());
				}
			},
			new Action() {	// [204] jump_statement = RETURN SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 return new Symbol(new ReturnStatement(null));
				}
			},
			new Action() {	// [205] jump_statement = RETURN expression.a SEMICOLON
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 2];
					final MultiExpression a = (MultiExpression) _symbol_a.value;
					 return new Symbol(new ReturnStatement(a));
				}
			},
			new Action() {	// [206] translation_unit = external_declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Program a = (Program) _symbol_a.value;
					 return new Symbol(a);
				}
			},
			new Action() {	// [207] translation_unit = translation_unit.a external_declaration.b
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Program a = (Program) _symbol_a.value;
					final Symbol _symbol_b = _symbols[offset + 2];
					final Program b = (Program) _symbol_b.value;
					 a.addProgram(b); return new Symbol(a);
				}
			},
			new Action() {	// [208] external_declaration = function_definition.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final FunctionDefinition a = (FunctionDefinition) _symbol_a.value;
					 Program p = new Program(); p.add(a); return new Symbol(p);
				}
			},
			new Action() {	// [209] external_declaration = declaration.a
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_a = _symbols[offset + 1];
					final Declaration a = (Declaration) _symbol_a.value;
					 
    Program p = new Program();
    if (a instanceof MultiVariableDeclaration){
      MultiVariableDeclaration d = (MultiVariableDeclaration)a;
      for(VariableDeclaration v : d){ 
        p.add(v);
      } 
    } else if (a instanceof StructTypeSpecification){
      p.add((StructTypeSpecification)a);
    } else {
      throw new RuntimeException("I don't know how to interpret "+a+" as an external declaration");
    }
    return new Symbol(p);
				}
			},
			new Action() {	// [210] function_definition = declaration_specifiers declarator declaration_list compound_statement
				public Symbol reduce(Symbol[] _symbols, int offset) {
					 throw new RuntimeException("I don't know how to parse declaration_specifiers declarator declaration_list compound_statement.");
				}
			},
			new Action() {	// [211] function_definition = declaration_specifiers.type declarator.nameAndArgs compound_statement.block
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_type = _symbols[offset + 1];
					final TypeSpecification type = (TypeSpecification) _symbol_type.value;
					final Symbol _symbol_nameAndArgs = _symbols[offset + 2];
					final Identifier nameAndArgs = (Identifier) _symbol_nameAndArgs.value;
					final Symbol _symbol_block = _symbols[offset + 3];
					final Statement block = (Statement) _symbol_block.value;
					 return new Symbol(new FunctionDefinition(type,nameAndArgs,block));
				}
			},
			new Action() {	// [212] function_definition = declarator.nameAndArgs declaration_list.decls compound_statement.block
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_nameAndArgs = _symbols[offset + 1];
					final Identifier nameAndArgs = (Identifier) _symbol_nameAndArgs.value;
					final Symbol _symbol_decls = _symbols[offset + 2];
					final ArrayList<Declaration> decls = (ArrayList<Declaration>) _symbol_decls.value;
					final Symbol _symbol_block = _symbols[offset + 3];
					final Statement block = (Statement) _symbol_block.value;
					 Statement block2 = new CompoundStatement(decls, block); return new Symbol(new FunctionDefinition(nameAndArgs,block2));
				}
			},
			new Action() {	// [213] function_definition = declarator.nameAndArgs compound_statement.block
				public Symbol reduce(Symbol[] _symbols, int offset) {
					final Symbol _symbol_nameAndArgs = _symbols[offset + 1];
					final Identifier nameAndArgs = (Identifier) _symbol_nameAndArgs.value;
					final Symbol _symbol_block = _symbols[offset + 2];
					final Statement block = (Statement) _symbol_block.value;
					 System.err.println("Warning - defaulting to int return type on function "+nameAndArgs); return new Symbol(new FunctionDefinition(new TypeSpecification("int"),nameAndArgs,block));
				}
			}
		};


    report = new Parser.Events(){
      public void scannerError(Scanner.Exception e)
      {
        throw new RuntimeException(e.getMessage());
      }
      public void syntaxError(Symbol e)
      {
      	if (e.value.equals("}")){
        	throw new RuntimeException("Unexpected \""+e.value+"\". Remember: Variable declarations in structs must all end with semicolons. ");
      	}
        throw new RuntimeException("Unexpected \""+e.value+"\"");
      }
    };
	}

	protected Symbol invokeReduceAction(int rule_num, int offset) {
		return actions[rule_num].reduce(_symbols, offset);
	}
}
