#include <apps/sample_p.h>
#include <apps/sample_v.h>


bool MICROBENCHMARKS = 0;

// driver to run the phases of the verifier
int main(int argc, char **argv)
{
  int batch_size;
  int num_repetitions;
  int num_inputs;
  int num_outputs;
  int num_cons;
  int num_vars;
  char prover_url[BUFLEN];
  char actor;
  int phase;
  int variant;
  
  parse_args(argc, argv, &actor, &phase, &batch_size, &num_repetitions, &num_inputs,
    prover_url, &variant);
  int optimize_answers = 1;
  
  
  num_cons = 9;
  num_inputs = 8;
  num_outputs = 1;
  num_vars = 8;
  

#ifdef INTERFACE_MPI

  MPI_Init(&argc, &argv);
  int rank;
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  if (rank == 0) {  // verifier
    SampleVerifier verifier(batch_size, num_repetitions,
      optimize_answers, prover_url, num_inputs, num_outputs, num_vars,
      num_cons);          
    verifier.begin_pepper();
  } else {  // prover
    SampleProver prover(0 /*phase*/, batch_size,
    num_repetitions, num_inputs, num_outputs, num_vars, num_cons);
    prover.handle_requests();
  }

#else
  if (actor == 'v') {
    SampleVerifier verifier(batch_size, num_repetitions,
      optimize_answers, prover_url, num_inputs, num_outputs, num_vars,
      num_cons);          
 
    verifier.begin_pepper();
  } else {
    if (argc > 2) {
      SampleProver prover(phase, batch_size,
      num_repetitions, num_inputs, num_outputs, num_vars, num_cons);
      prover.handle_terminal_request();
    }
    else {
      phase = 0;
      batch_size = 100;
      num_repetitions = 70;
      num_inputs = 1000;

      SampleProver prover(phase, batch_size, num_repetitions);
      prover.handle_http_requests();
    }
  }
#endif

  return 0;
}

